﻿Type=Class
Version=2.71
@EndOfDesignText@
'Class module

#Event: Menu_Open
#Event: Menu_Closed
#Event: Click (ReturnValue as Object)
#Event: LongClick (ReturnValue as Object)
#Event: Home_Click
#Event: ND_Move (Opening as Boolean)
#Event: ND_Open
#Event: ND_Closed
Sub Class_Globals
	'Temp Varialble
	Private TitleWidth As Int 
	Private tmrSubTitle As Timer 
	'General Variables
	Private mTypeFace As Typeface = Typeface.DEFAULT
	Private mABModule, mNDModule As Object
	Private mABSub, mNDSub As String 

	Private mActivity As Activity 
	Private mMenuTop As Int = 0 
	Private mDark As Boolean = False
	
	Private mScale As Float = 1
	Private mAutoScaleRate As Float = 0
#Region ActionBar
	Private mABAutoAdjustImageSize As Boolean = True
	'Properties Variables
	Private mAppName As String =""
	Private mAppTitle As String = ""
	Private mAppSubTitle As String = ""
	Private mAppLogo As Bitmap = Null
	Private mHeight As Int = 48dip
	Private mAppTitleTextSize As Int = 18
	Private mAppSubTitleTextSize As Int = 14
	Private mAppTitleTextColor As Int = Colors.Black 
	Private mAppSubTitleTextColor As Int = Colors.Black
	

	Private mImageSize As Int = 32dip
	Private mButtonColor As Int = Colors.Transparent
	Private mButtonPressedColor As Int = Colors.RGB(29,162,235)
	Private mButtonCornerRadius As Int = 0dip
	Private mMenuAnimationDuration As Int = 300
	Private mActionBarColor As Int = Colors.LightGray   'Colors.Red 
	Private mActionBarDividerColor As Int = Colors.ARGB(40 ,0,0,0)
	Private mActionBarDividerHeight As Int =2dip

	'Internal
	Private drwButtonColor,drwButtonPressedColor As ColorDrawable
	Private FinishedLoading As Boolean = False
	Private pnlActionBar, pnlOverflow, pnlLogo, pnlIconNavigationDrawer, pnlDivider As Panel
	Private lstRightButtons As List 
	Private imgLogo, imgArrowUp, imgOverflow As ImageView
	Private lblAppTitle, lblAppSubTitle As Label
#End Region

#Region NavigationDrawer
	'Variables
	Private mSideBarWidth As Int = 200dip
	Private mSideBarShadowColor As Int = Colors.ARGB(190,0,0,0)
	Private mSideBarOpeningDuration As Int = 300
	Private mSideBarClosingDuration As Int = 100
	Private mSideBarBackColor As Int = Colors.RGB(243,243,244) 'Colors.RGB(222,219,222)
	Private mSideBarItemBackColor As Int = Colors.Transparent 
	Private mNDTextColor As Int =Colors.Black 
	Private mNDTextSize As Int = 18
	Private mNDUseSymbols As Boolean = True
	
	Private sbInterpolator As Float
	Private sbAnimInProgress As Byte
	Private sbStopAnim As Boolean

	Private sbIsVisible As Boolean
	Private sbIsOpening As Boolean
	Private pnlSidebarStartX As Int
	Private sbStartX As Float 
	Private FROM_OPEN As Boolean:  FROM_OPEN = True
	Private FROM_CLOSE As Boolean: FROM_CLOSE = False
	Private OPEN_ANIM As Boolean:  OPEN_ANIM = False
	Private CLOSE_ANIM As Boolean: CLOSE_ANIM = True
	Private OPENING As Byte: OPENING = 1
	Private CLOSING As Byte: CLOSING = 2
	'Views
	Private pnlNavigationDrawer As Panel
	Private pnlGesture As Panel
	Private pnlShadow, pnlNDShadow As Panel
	Private lsvNavigationDrawer As ListView
	Private imgNavDrawer As ImageView
	
#End Region 
	'Private FirstScroll As Boolean = False
	Public Menu As ahaMenu 
End Sub
Sub tmrSubTitle_Tick
	lblAppSubTitle.Width = lblAppSubTitle.Width - 1dip
	tmrSubTitle.Enabled = False
End Sub
'Initializes the Actionbar.
'<B>Note:</B> NavigationDrawer has to be initialized with CreateNavigationDrawer, ideally as last call in Activity_Create
'Activity has to be an Activity,ABPanel a Panel (Pass NULL or Activity if the Actionbar should be added to the activity) Module = Me, EventName: Name for the Event Subs. (Example: ActionBar)
'
'<B>Dont forget to filter the KeyPress in your activity</B>
'<code>Sub Activity_KeyPress (KeyCode As Int) As Boolean
'	Return ActionBar.Keypress(KeyCode)
'End Sub</code>	
Public Sub Initialize(Activity As Activity, Parent As Panel,Module As Object, EventName As String)  
	mActivity = Activity
	mABModule = Module
	mABSub = EventName
	
tmrSubTitle.Initialize("tmrSubTitle",1000)
tmrSubTitle.Enabled = True
#Region ActionBar
	drwButtonColor.Initialize(mButtonColor,mButtonCornerRadius)
	drwButtonPressedColor.Initialize(mButtonPressedColor,mButtonCornerRadius)

	pnlActionBar.Initialize("ActionBar")
	pnlActionBar.Color = mActionBarColor 
	
	Dim pnl As Panel
	pnl = Parent
	If Not(pnl.IsInitialized) Then
		Activity.AddView(pnlActionBar,0dip,0dip,100%x, mHeight)
	Else
		mHeight = Parent.Height 
		mMenuTop = Parent.Top 
		Parent.AddView(pnlActionBar,0dip,0dip,Parent.Width , mHeight)
	End If
	
	If mABAutoAdjustImageSize Then mImageSize = (mHeight/48dip) * mImageSize

	pnlLogo.Initialize("btnLogo")
	Dim sldActionButton As StateListDrawable
	sldActionButton.Initialize 
	sldActionButton.AddState(sldActionButton.State_Pressed,drwButtonPressedColor)
	sldActionButton.AddCatchAllState(drwButtonColor)
	pnlLogo.Background  = sldActionButton
	pnlActionBar.AddView(pnlLogo,0dip, 0dip,20dip,mHeight-mActionBarDividerHeight)
	imgLogo.Initialize("")
	imgLogo.Gravity = Gravity.FILL
	imgLogo.Visible = False
	pnlLogo.AddView(imgLogo,15dip,2dip,mHeight-4dip,mHeight-4dip)
	
	imgArrowUp.Initialize("")
	imgArrowUp.Gravity = Gravity.FILL 
	imgArrowUp.Visible = False
	SetDrawable(imgArrowUp,"ahaab_back")
	pnlLogo.AddView(imgArrowUp, imgLogo.Left - 12dip,mHeight/2 - 12dip,24dip,24dip)
	
	lblAppTitle.Initialize("")
	lblAppTitle.Gravity = Gravity.CENTER_VERTICAL 
	lblAppTitle.TextColor = mAppTitleTextColor
	lblAppTitle.TextSize = mAppTitleTextSize
	pnlActionBar.AddView(lblAppTitle,0dip,0dip,pnlLogo.Width,pnlLogo.Height)
	lblAppSubTitle.Initialize("")
	lblAppSubTitle.Gravity = Gravity.TOP
	lblAppSubTitle.TextColor = mAppSubTitleTextColor
	lblAppSubTitle.TextSize = mAppSubTitleTextSize
	pnlActionBar.AddView(lblAppSubTitle,0dip,0dip,pnlLogo.Width,pnlLogo.Height)

	pnlDivider.Initialize("")
	pnlDivider.Color = mActionBarDividerColor
	pnlActionBar.AddView(pnlDivider,0dip,mHeight-mActionBarDividerHeight,pnlActionBar.Width ,mActionBarDividerHeight)

	
	Menu.Initialize(mActivity,mABModule,mABSub, pnlActionBar.Width,mMenuTop + mHeight-16dip)
	lstRightButtons.Initialize 
#End Region 

#Region Sidebar

	pnlShadow.Initialize("Shadow")
	pnlShadow.Color = mSideBarShadowColor
	pnlShadow.Visible = False
	mActivity.AddView(pnlShadow, 0dip, mHeight, 100%x, getParentHeight-mHeight)

	pnlNavigationDrawer.Initialize("Block")
	pnlNavigationDrawer.Color = mSideBarBackColor
	mActivity.AddView(pnlNavigationDrawer, - mSideBarWidth, mHeight, mSideBarWidth, getParentHeight-mHeight)
	sbInterpolator = 0.7
	sbIsVisible = False
	
	pnlNDShadow.Initialize("")
	pnlNDShadow.Visible = False
	mActivity.AddView(pnlNDShadow, 0dip,pnlNavigationDrawer.Top,11dip,pnlNavigationDrawer.Height)
	SetNinePatchDrawable(pnlNDShadow,"drawer_shadow")
	'pnlShadow2.Left = 0dip
	
	lsvNavigationDrawer.Initialize("lsvNavigationDrawer")
	lsvNavigationDrawer.Color = mSideBarItemBackColor
	lsvNavigationDrawer.TwoLinesAndBitmap.SecondLabel.Visible = False
	lsvNavigationDrawer.TwoLinesAndBitmap.ItemHeight = 48dip
	lsvNavigationDrawer.TwoLinesAndBitmap.Label.Gravity = Gravity.CENTER_VERTICAL
	lsvNavigationDrawer.TwoLinesAndBitmap.Label.Height = lsvNavigationDrawer.TwoLinesAndBitmap.ItemHeight
	lsvNavigationDrawer.TwoLinesAndBitmap.Label.Top = 0
	lsvNavigationDrawer.TwoLinesAndBitmap.ImageView.SetLayout(13dip, 13dip, 24dip, 24dip)
	lsvNavigationDrawer.TwoLinesAndBitmap.Label.TextSize = mNDTextSize 
	lsvNavigationDrawer.TwoLinesAndBitmap.Label.TextColor = mNDTextColor
	
	lsvNavigationDrawer.SingleLineLayout.ItemHeight = 48dip
	lsvNavigationDrawer.SingleLineLayout.Label.Gravity = Gravity.CENTER_VERTICAL
	lsvNavigationDrawer.SingleLineLayout.Label.Height = lsvNavigationDrawer.SingleLineLayout.ItemHeight
	lsvNavigationDrawer.SingleLineLayout.Label.Top = 0
	lsvNavigationDrawer.SingleLineLayout.Label.TextSize = mNDTextSize 
	lsvNavigationDrawer.SingleLineLayout.Label.TextColor = mNDTextColor

	
	pnlNavigationDrawer.AddView(lsvNavigationDrawer, 0, 0, pnlNavigationDrawer.Width - 1dip, pnlNavigationDrawer.Height)
#End Region 
		
	FinishedLoading = True
	Redraw

End Sub
#Region Navigation Drawer
Public Sub CreateNavigationDrawer (Module As Object, EventName As String)
	mNDModule = Module
	mNDSub = EventName

	If Not (pnlIconNavigationDrawer.IsInitialized) Then
		pnlIconNavigationDrawer.Initialize("")'BtnNavDrawer
		
		imgNavDrawer.Initialize("")
		imgNavDrawer.Gravity = Gravity.FILL
		pnlIconNavigationDrawer.AddView(imgNavDrawer,0dip,mHeight/2-12dip,24dip,24dip)
		'Redraw
	End If
	 
		If mDark = True Then
			SetDrawable(imgNavDrawer,"ahaab_ic_drawer_dark")
		Else
			SetDrawable(imgNavDrawer,"ahaab_ic_drawer")
		End If
	pnlActionBar.AddView(pnlIconNavigationDrawer,-0dip,0dip,24dip,mHeight-mActionBarDividerHeight)
	EnableSwipeGesture(True)
	
End Sub
Private Sub EnableSwipeGesture(Enabled As Boolean)
	If Not(Enabled) Then
		If pnlGesture.IsInitialized Then pnlGesture.RemoveView
		pnlGesture = Null
		Return
	End If

	If pnlGesture.IsInitialized Then
		pnlGesture.SetLayout(pnlNavigationDrawer.Left + pnlNavigationDrawer.Width , mHeight, 25dip, getParentHeight-mHeight)
	Else
		pnlGesture.Initialize("")
		mActivity.AddView(pnlGesture, pnlNavigationDrawer.Left + pnlNavigationDrawer.Width , mHeight,  25dip, getParentHeight-mHeight)
		Dim r As Reflector
		r.Target = pnlGesture
		r.SetOnTouchListener("Gesture_onTouch")
	End If
End Sub
Public Sub AddNavigationDrawerItem(Text As String, Image As Bitmap, ReturnValue As Object)
	If mNDUseSymbols = True Then
		If Not(Image.IsInitialized) Then
			lsvNavigationDrawer.AddTwoLinesAndBitmap2(Text, "", Null, ReturnValue)
		Else
			lsvNavigationDrawer.AddTwoLinesAndBitmap2(Text, "", Image, ReturnValue)
		End If
	Else
		lsvNavigationDrawer.AddSingleLine2(Text, ReturnValue)
	End If


	Dim AddSpacing As Int = 0
	If mNDUseSymbols = True Then AddSpacing = 110dip
	Dim C As Canvas
	C.Initialize(pnlNavigationDrawer)
	Dim X As Int
	X = C.MeasureStringWidth( Text, mTypeFace, mNDTextSize) 
	If X > lsvNavigationDrawer.Width - AddSpacing Then
		pnlNavigationDrawer.Width = X + AddSpacing
		pnlNavigationDrawer.Left = -pnlNavigationDrawer.Width 
		lsvNavigationDrawer.Width = pnlNavigationDrawer.Width -1dip
	End If

	lsvNavigationDrawer.Height = lsvNavigationDrawer.Size * 49dip
	If lsvNavigationDrawer.Height > 100%y - pnlNavigationDrawer.Top Then lsvNavigationDrawer.Height = 100%y-pnlNavigationDrawer.top '-50dip
End Sub
Private Sub lsvNavigationDrawer_ItemClick (Position As Int, Value As Object)
	CloseNavigationDrawer
	If SubExists(mNDModule, mNDSub & "_Click") Then
		CallSub2(mNDModule, mNDSub & "_Click", Value)
	End If
End Sub
Private Sub Block_Touch(Action As Int, X As Float, Y As Float)
	CloseNavigationDrawer
End Sub

#Region SidebarAnimation
Private Sub Animate(Progression As Int)
	pnlNavigationDrawer.Left = pnlSidebarStartX + Progression
	pnlNDShadow.Left = pnlNavigationDrawer.Left + pnlNavigationDrawer.Width 
	If pnlGesture.IsInitialized Then pnlGesture.Left = pnlNavigationDrawer.Left + pnlNavigationDrawer.Width 

	sbIsVisible = (CalcDistance(FROM_CLOSE) <> 0)
	
	If sbIsVisible Then
		Private Transparency As Double 
		Transparency = 1 - ((pnlNavigationDrawer.left * -1) / pnlNavigationDrawer.Width)		
		Progress(Transparency)
	End If
End Sub
Private Sub AnimateSidebar(Close As Boolean)
	' Calculates the animation distance and duration (the closer it is to the position to reach, the shorter the duration)
	Dim AnimDistance, AnimDuration As Int
	Dim PctStillToMove As Float
	If Close Then
		AnimDistance = CalcDistance(FROM_CLOSE)
		PctStillToMove = Abs(AnimDistance) / pnlNavigationDrawer.Width
		AnimDuration = mSideBarClosingDuration * PctStillToMove
		sbAnimInProgress = CLOSING
		'If tmpTitle <> ""  Then setABTitle(tmpTitle)

	Else
		'If CalcDistance(FROM_OPEN) = 0  Then
'		If mAppName <> "" Then
'			tmpTitle = mAppTitle
'			setABTitle(mAppName)
'		End If
		pnlNDShadow.Visible = True
		AnimDistance = CalcDistance(FROM_OPEN)
		PctStillToMove = Abs(AnimDistance) / pnlNavigationDrawer.Width
		AnimDuration = mSideBarOpeningDuration * PctStillToMove
		sbAnimInProgress = OPENING
	End If
	If AnimDistance = 0 Then
		' No distance -> no need for an animation
		sbAnimInProgress = 0
		TriggerFinalEvent
		Return
	End If
	pnlSidebarStartX = pnlNavigationDrawer.Left
	' Animates the views
	sbStopAnim = False
	Dim EndTime, DeltaTime As Long
	EndTime = DateTime.Now + AnimDuration
	Do While DateTime.Now < EndTime
    	DeltaTime = EndTime - DateTime.Now
		Animate(Power(1 - (DeltaTime / AnimDuration), sbInterpolator) * AnimDistance)
		If SubExists(mNDModule, mNDSub & "_NavigationDrawer_Move") Then
			' Triggers an onMove event
			CallSub2(mNDModule, mNDSub & "_NavigationDrawer_Move", Not(Close))
		End If
    	DoEvents 'Processes the draw messages and keeps the UI responsive
		If sbStopAnim Then
			DeltaTime = 0
			Exit
		End If
	Loop
	If DeltaTime <> 0 Then Animate(AnimDistance)

	sbAnimInProgress = 0
	TriggerFinalEvent
End Sub
Private Sub Gesture_onTouch(ViewTag As Object, Action As Int, X As Float, Y As Float, MotionEvent As Object) As Boolean

	Private Transparency As Double 
	If Action = 0 Then
		sbStopAnim = True
		sbStartX = X
		pnlNDShadow.Visible = True
		
	Else If Action = 2 Then
		Dim tmpDistance As Int = X-sbStartX
		If tmpDistance < 0 Then tmpDistance = tmpDistance * (-1)
		'If tmpDistance <5dip Then Return False
		
		'If FirstScroll Then	FirstScroll = False
	
		' Moves the views to follow the finger
		Dim OldPos As Int = pnlNavigationDrawer.Left 
		'pnlShadow.Visible = True
		pnlNavigationDrawer.Left = Max(-pnlNavigationDrawer.Width, Min(pnlNavigationDrawer.Left + X - sbStartX, 0))
		pnlNDShadow.Left = pnlNavigationDrawer.Left + pnlNavigationDrawer.Width 
		If pnlGesture.IsInitialized Then pnlGesture.Left = pnlGesture.Left -OldPos + pnlNavigationDrawer.Left    'pnlNavigationDrawer.Left + pnlNavigationDrawer.Width 
		sbIsOpening = X > sbStartX
		sbIsVisible = (CalcDistance(FROM_CLOSE) <> 0)

		Transparency = 1 - ((pnlNavigationDrawer.left * -1) / pnlNavigationDrawer.Width)
		Progress(Transparency)

		' Triggers an onMove event
		If SubExists(mNDModule,mNDSub &  "_NavigationDrawer_Move") Then
			If sbIsOpening Then
				CallSub2(mNDModule, mNDSub & "_NavigationDrawer_Move", True)
			Else
				CallSub2(mNDModule, mNDSub & "_NavigationDrawer_Move", False)
			End If
		End If
		
		
		
	Else If Action = 1 Then
	'pnlShadow.Visible = False
		'If  FirstScroll = True Then
		'	SendClick(mParent, X, Y)
		'Else
			' Is there a final movement to do?
		'If FirstScroll = False Then
			'ToastMessageShow("zu",False)
			If  sbIsVisible Then
				'CloseNavigationDrawer
			'ToastMessageShow("visu",False)
				If sbIsOpening Then
					CallSubDelayed2(Me, "AnimateSidebar", OPEN_ANIM)
				Else
					CallSubDelayed2(Me, "AnimateSidebar", CLOSE_ANIM)
				End If
			Else
				TriggerFinalEvent
			End If
		'End If
		
		'End If
	End If
	Return True
End Sub
#End Region 

Public Sub OpenNavigationDrawer
	'inNavDrawerAnimation.Start(pnlIconNavigationDrawer)
	If sbAnimInProgress = CLOSING Then
		' Stops the current closing animation to start an opening animation
		sbStopAnim = True
		CallSubDelayed2(Me, "AnimateSidebar", OPEN_ANIM)
	Else If sbAnimInProgress = 0 Then
		' Starts an opening animation if there's not already one running
		AnimateSidebar(OPEN_ANIM)
	End If
End Sub

Public Sub CloseNavigationDrawer
	If sbAnimInProgress = OPENING Then
		' Stops the current opening animation to start a closing animation
		sbStopAnim = True
		CallSubDelayed2(Me, "AnimateSidebar", CLOSE_ANIM)
	Else If sbAnimInProgress = 0 Then
		' Starts a closing animation if there's not already one running
		AnimateSidebar(CLOSE_ANIM)
	End If
End Sub

Private Sub BtnNavDrawer_Click
	If CalcDistance(FROM_OPEN) = 0 Then
		CloseNavigationDrawer'OpenNavigationDrawer
	Else
		OpenNavigationDrawer'CloseNavigationDrawer 
	End If
End Sub

Private Sub CalcDistance(FromOpen As Boolean) As Int
	' Calculates the distance between the current position and the position to reach
	If FromOpen Then
		Return - pnlNavigationDrawer.Left
	Else
		Return - pnlNavigationDrawer.Left - pnlNavigationDrawer.Width
	End If
End Sub

Private Sub TriggerFinalEvent
	' Triggers an onFullyOpen or onFullyClosed event
	If CalcDistance(FROM_OPEN) = 0  Then
		sbIsOpening = False
		pnlGesture.Width = 100%x - pnlGesture.Left 
		If SubExists(mNDModule, mNDSub & "_NavigationDrawer_Open") Then CallSub(mNDModule, mNDSub & "_NavigationDrawer_Open")	
	Else If CalcDistance(FROM_CLOSE) <= 0 Then
		pnlNavigationDrawer.Left = - pnlNavigationDrawer.Width 
		pnlNDShadow.Visible = False
		pnlShadow.Visible = False
		pnlGesture.Width = 25dip
		'If Not (lblAppTitle.Text = tmpTitle) AND Not(mAppName = "") Then 
		'	setABTitle(tmpTitle)
		'End If
		If Not (lblAppTitle.Text = mAppTitle) Then 
			lblAppTitle.Text = mAppTitle
			lblAppTitle.Width = TitleWidth
			lblAppSubTitle.Width = TitleWidth
		End If
		'If Not (lblAppTitle.Text = tmpTitle) AND Not(mAppName = "") Then TitleBarAnim.Start(lblAppTitle)
		If SubExists(mNDModule, mNDSub & "_NavigationDrawer_Closed") Then CallSub(mNDModule, mNDSub & "_NavigationDrawer_Closed")
	End If
End Sub
Private Sub Shadow_Click
	CloseNavigationDrawer 
End Sub
Private Sub outNavDrawerAnimation_AnimationEnd
	pnlIconNavigationDrawer.Left = 0dip
End Sub
Private Sub inNavDrawerAnimation_AnimationEnd
	pnlIconNavigationDrawer.Left = -10dip
End Sub

Private Sub Progress (Percentage As Double)
	Dim v As Panel 
	Dim i As Int 
	For i = 0 To lstRightButtons.Size -1
		v = lstRightButtons.get(i)
		SetAlpha(v.GetView(0), 255* (1-Percentage))
		If Percentage >= 0.9 Then
			v.Visible = False
		Else
			v.Visible = True
		End If
	Next
	
	Dim argb() As Int
   	argb = GetARGB(mSideBarShadowColor)
	pnlShadow.Color = Colors.argb(argb(0) * Percentage,argb(1),argb(2),argb(3))

	If Percentage >= 0.05 Then
		pnlShadow.Visible = True
	Else
		pnlShadow.Visible = False
	End If
	
	pnlIconNavigationDrawer.Left = - (10* Percentage)
	
	If Not (mAppName = "") AND Not (lblAppTitle.Text = mAppName) Then 
		lblAppTitle.Width =  70%x 
		lblAppSubTitle.Width = 70%x 
		lblAppTitle.Text = mAppName
	End If
'	If Not(mAppName = "") AND Not (lblAppTitle.Text = mAppName) Then 
'		tmpTitle = mAppTitle
'		setABTitle(mAppName)
'	End If
End Sub

#End Region

#Region Menus
Public Sub AddMenuItem(Text As String, image As Bitmap,ReturnValue As Object )

	If Not(pnlOverflow.IsInitialized) Then
		pnlOverflow.Initialize("Overflow")
		imgOverflow.Initialize("")
		imgOverflow.Gravity = Gravity.FILL 
		pnlOverflow.AddView(imgOverflow, mHeight/2 - mImageSize /2,mHeight/2 - mImageSize / 2,mImageSize,mImageSize)
		If mDark = True Then
			SetDrawable (imgOverflow,"ahaab_overflow_dark")
		Else
			SetDrawable (imgOverflow,"ahaab_overflow")
		End If
		Dim sldActionButton As StateListDrawable
		sldActionButton.Initialize 
		sldActionButton.AddState(sldActionButton.State_Pressed,drwButtonPressedColor)
		sldActionButton.AddCatchAllState(drwButtonColor)
		pnlOverflow.Background  = sldActionButton
		pnlActionBar.AddView(pnlOverflow,pnlActionBar.Width -mHeight,0dip,mHeight,mHeight-mActionBarDividerHeight)
		RearrangeButtons
	End If
	
Menu.AddMenuItem(Text, image,ReturnValue)
End Sub
Private Sub Overflow_Click
	If NDisVisible Then CloseNavigationDrawer
	Menu.TriggerMenu 
End Sub
Public Sub CallMenu
	Overflow_Click
End Sub
#End Region

#Region ActionButtons
Private Sub btnLogo_Click
	If pnlIconNavigationDrawer.IsInitialized Then
		BtnNavDrawer_Click
		Return
	End If
	
	If SubExists(mABModule, mABSub & "_Home_Click") Then
		CallSub(mABModule, mABSub & "_Home_Click")
	End If
End Sub

Public Sub AddActionButton (Text As String, Image As Bitmap, ReturnValue As Object) As View 
	Dim AdditionalSpace As Int = 0dip
	If pnlOverflow.IsInitialized Then AdditionalSpace = mHeight+1dip
	
	If Image = Null AND Text = "" Then
		Return Null
	End If
	'If pnlActionBar.Width  - (lstRightButtons.Size*(mHeight+1dip))-2*mHeight <= (pnlLogo.Left + pnlLogo.Width)    Then
	If pnlActionBar.Width  - (lstRightButtons.Size*(mHeight+1dip))-2*mHeight <= (lblAppTitle.Left + lblAppTitle.Width)    Then
		AddMenuItem(Text,Image,ReturnValue)
		Return Null
	End If
	
	Dim pnlButton As Panel
	pnlButton.Initialize("ActionButton")
	Dim sldActionButton As StateListDrawable
	sldActionButton.Initialize 
	sldActionButton.AddState(sldActionButton.State_Pressed,drwButtonPressedColor)
	sldActionButton.AddCatchAllState(drwButtonColor)
	pnlButton.Background  = sldActionButton

	pnlButton.Tag =  ReturnValue
	If Image <> Null Then
		Dim ivIcon As ImageView
		ivIcon.Initialize("")
		ivIcon.Gravity = Gravity.FILL 
		ivIcon.Bitmap = Image
	pnlButton.AddView(ivIcon, mHeight/2 - mImageSize /2,mHeight/2 - mImageSize / 2,mImageSize,mImageSize)
	End If
	
	lstRightButtons.Add(pnlButton)
	pnlActionBar.AddView(pnlButton,pnlActionBar.Width -((lstRightButtons.Size*(mHeight+1dip))+AdditionalSpace),0dip,mHeight,mHeight-mActionBarDividerHeight)
	'Redraw
	
	Return pnlButton
End Sub
Private Sub ActionButton_Click
	Dim btn As Panel
	btn = Sender

	If SubExists(mABModule, mABSub & "_Click") Then
		CallSub2(mABModule, mABSub & "_Click", btn.Tag)
	End If
End Sub
Sub ActionButton_LongClick
	Dim btn As Panel
	btn = Sender

	If SubExists(mABModule, mABSub & "_LongClick") Then
		CallSub2(mABModule, mABSub & "_LongClick", btn.Tag)
	End If	
End Sub
#End Region 


#Region Settings
'Application Name
'Used for the NavigationDrawer
'According Android Design Guidelines the Title should be replaced by the Application Name if Navigation Drawer is expanded.
'More information: <link>http://developer.android.com/design/patterns/navigation-drawer.html|http://developer.android.com/design/patterns/navigation-drawer.html</link>
Public Sub getApplicationName As String
	Return mAppName
End Sub
Public Sub setApplicationName (ApplicationName As String)
	mAppName = ApplicationName
End Sub
'Title of the ActionBar  (for example Activity Name)
Public Sub getABTitle As String
	Return mAppTitle
End Sub
Public Sub setABTitle (ABTitle As String)
	mAppTitle = ABTitle
	
	lblAppTitle.Text = mAppTitle

	Dim C As Canvas
	C.Initialize(pnlActionBar)
	Dim X, Y As Int
	X = C.MeasureStringWidth( mAppTitle, mTypeFace, mAppTitleTextSize) +5dip '* 1dip +5dip
	Y = C.MeasureStringHeight( mAppTitle, mTypeFace, mAppTitleTextSize)+10dip '* 1dip
	lblAppTitle.Width = X 
	TitleWidth = lblAppTitle.Width
	If  imgLogo.Visible = False Then
		lblAppTitle.Left = 20dip
		'pnlLogo.Width = 20dip
	Else
		lblAppTitle.Left = imgLogo.Left + imgLogo.width  + 2dip
		'pnlLogo.Width = mHeight + 13dip
	End If
	
	lblAppTitle.Height = Y'
	lblAppTitle.Top = mHeight / 2 - lblAppTitle.Height /2

	If Not(mAppSubTitle = "") Then setABSubTitle(mAppSubTitle)

End Sub
'Subtitle of the ActionBar
Public Sub getABSubTitle As String
	Return mAppSubTitle
End Sub
Public Sub setABSubTitle (ABSubTitle As String)
	mAppSubTitle = ABSubTitle
	lblAppSubTitle.Text = mAppSubTitle
	
	If mAppSubTitle = "" Then
		lblAppTitle.Top = mHeight / 2 - lblAppTitle.Height /2
	Else
		lblAppSubTitle.Top = mHeight/2
		lblAppSubTitle.Left = lblAppTitle.Left
		lblAppSubTitle.Width = lblAppTitle.Width
		lblAppTitle.Top = mHeight/2 - lblAppTitle.Height * 0.7' lblAppSubTitle.Top - lblAppTitle.Height
		Dim r As Reflector
  		r.Target = lblAppSubTitle
  		r.RunMethod2("setLines", 1, "java.lang.int")
    	r.RunMethod2("setHorizontallyScrolling", True, "java.lang.boolean") 
   		r.RunMethod2("setEllipsize", "MARQUEE", "android.text.TextUtils$TruncateAt")
   		r.RunMethod2("setSelected", True, "java.lang.boolean")
	End If
End Sub
'Application/Activity Icon
Public Sub getABIcon As Bitmap
	Return mAppLogo
End Sub
Public Sub setABIcon (ABIcon As Bitmap)
	mAppLogo = ABIcon
	imgLogo.Bitmap = mAppLogo
	imgLogo.Visible = True
	pnlLogo.Width = mHeight + 13dip
	setABTitle (mAppTitle)
End Sub
'The Height of the ActionBar
'In PortraitMode normally 48dip, in Landscape 40 dip
'You could do something like this in Activity_Create:
'	<code>If 100%y >= 100%x Then 'Portrait
'		ActionBar.Height = 48dip
'	Else 'Landscape
'		ActionBar.Height = 40dip
'	End If</code>
Public Sub getABHeight As Int 
	Return mHeight
End Sub
Public Sub setABHeight (ABHeight As Int)
	mHeight = ABHeight

	pnlActionBar.Height = mHeight
	pnlLogo.Height = mHeight-mActionBarDividerHeight
	
	imgLogo.Width = mHeight -4dip
	imgLogo.Height = mHeight - 4dip
	imgArrowUp.Top = mHeight/2 - 12dip
	Menu.RepostitionMenu(pnlActionBar.Width -200dip,mMenuTop + mHeight-16dip)
'	pnlMenu.Top =  mHeight-16dip
	pnlShadow.Top = mHeight
	pnlShadow.Height = 100%y - mHeight
	pnlNavigationDrawer.Top = mHeight
	pnlNavigationDrawer.Height = 100%y - mHeight
	If pnlIconNavigationDrawer.IsInitialized Then
		pnlIconNavigationDrawer.Height =  mHeight-mActionBarDividerHeight
		imgNavDrawer.Top = mHeight/2-12dip
	End If
	pnlDivider.Height = mActionBarDividerHeight
	pnlDivider.Top = mHeight-mActionBarDividerHeight
End Sub
'TextSize of the Items in the Navigation Drawer
Public Sub getNDTextSize As Int 
	Return mNDTextSize
End Sub
Public Sub setNDTextSize (NDTextSize As Int)
	mNDTextSize = NDTextSize 
	lsvNavigationDrawer.TwoLinesAndBitmap.Label.TextSize = NDTextSize 
End Sub
'TextSize of the Menu Items 
Public Sub getMenuTextSize As Int 
	Return Menu.TextSize
End Sub
Public Sub setMenuTextSize (MenuTextSize As Int)
	Menu.TextSize = MenuTextSize
End Sub
'TextSize of the ActionBar - Title
Public Sub getABTitleTextSize As Int 
	Return mAppTitleTextSize
End Sub
Public Sub setABTitleTextSize (ABTitleTextSize As Int)
	mAppTitleTextSize = ABTitleTextSize
	lblAppTitle.TextSize = mAppTitleTextSize
	setABTitle(mAppTitle)
	setABSubTitle(mAppSubTitle)
End Sub
'TextSize of the ActionBar - Subtitle
Public Sub getABSubTitleTextSize As Int 
	Return mAppSubTitleTextSize
End Sub
Public Sub setABSubTitleTextSize (ABSubTitleTextSize As Int)
	mAppSubTitleTextSize = ABSubTitleTextSize
	lblAppSubTitle.TextSize = mAppSubTitleTextSize
	setABTitle(mAppTitle)
	setABSubTitle(mAppSubTitle)
End Sub
'TextColor of the ActionBar - Title
Public Sub getABTitleTextColor As Int 
	Return mAppTitleTextColor
End Sub
Public Sub setABTitleTextColor (ABTitleTextColor As Int)
	mAppTitleTextColor = ABTitleTextColor
	lblAppTitle.Textcolor = mAppTitleTextColor
End Sub
'TextColor of the ActionBar - Subtitle
Public Sub getABSubTitleTextColor As Int 
	Return mAppSubTitleTextColor
End Sub
Public Sub setABSubTitleTextColor (ABSubTitleTextColor As Int)
	mAppSubTitleTextColor = ABSubTitleTextColor
	lblAppSubTitle.TextColor = mAppSubTitleTextColor
	'Redraw
End Sub
'TextColor of the Menu Entries
Public Sub getMenuTextColor As Int 
	Return Menu.TextColor 
End Sub
Public Sub setMenuTextColor (MenuTextColor As Int)
	Menu.TextColor = MenuTextColor
	'lsvMenu.TwoLinesAndBitmap.Label.TextColor = mMenuTextColor
End Sub
'TextColor of the NavigationDrawer Entries
Public Sub getNDTextColor As Int 
	Return mNDTextColor
End Sub
Public Sub setNDTextColor (NDTextColor As Int)
	mNDTextColor = NDTextColor
	lsvNavigationDrawer.TwoLinesAndBitmap.Label.TextColor = mNDTextColor
End Sub
'Width and Height of the ActionBar Icons-
'Has to be set before ActionBar Buttons are created!
Public Sub getABButtonImageSize As Int 
	Return mImageSize
End Sub
Public Sub setABButtonImageSize (ABButtonImageSize As Int)
	mImageSize = ABButtonImageSize
End Sub
'Color of the ActionButtons
Public Sub getABButtonColor As Int 
	Return mButtonColor
End Sub
Public Sub setABButtonColor (ABButtonColor As Int)
	mButtonColor = ABButtonColor
	Redraw
End Sub
'Color of the Pressed Button
Public Sub getABButtonPressedColor As Int 
	Return mButtonPressedColor
End Sub
Public Sub setABButtonPressedColor (ABButtonPressedColor As Int)
	mButtonPressedColor = ABButtonPressedColor
	Redraw
End Sub
'Radius of the ActionBar - Buttons
Public Sub getABButtonCornerRadius As Int 
	Return mButtonCornerRadius
End Sub
Public Sub setABButtonCornerRadius (ABButtonCornerRadius As Int)
	mButtonCornerRadius = ABButtonCornerRadius
	Redraw
End Sub
'Duration of the Menu Animation in Milliseconds
Public Sub getMenuAnimationDuration As Int 
	Return mMenuAnimationDuration
End Sub
Public Sub setMenuAnimationDuration (MenuAnimationDuration As Int)
	mMenuAnimationDuration = MenuAnimationDuration
	Menu.MenuAnimationDuration = mMenuAnimationDuration
'	inNavDrawerAnimation.Duration = mMenuAnimationDuration
'	outNavDrawerAnimation.Duration = mMenuAnimationDuration
End Sub
'Color of the Items in the Menu
Public Sub getMenuItemBackColor As Int
	Return Menu.MenuItemBackColor
End Sub
Public Sub setMenuItemBackColor (MenuItemBackColor As Int)
	Menu.MenuItemBackColor = MenuItemBackColor
End Sub
'BackColor of the ActionBar
'To set a drawble or 9.patch use ActionBarPanel
Public Sub getABBackColor As Int 
	Return mActionBarColor
End Sub
Public Sub setABBackColor (ABBackColor As Int)
	mActionBarColor = ABBackColor
	pnlActionBar.Color = mActionBarColor
	'Redraw
End Sub
'Color of the Dividerline
Public Sub getABDividerColor As Int 
	Return mActionBarDividerColor
End Sub
Public Sub setABDividerColor (ABDividerColor As Int)
	mActionBarDividerColor = ABDividerColor
	pnlDivider.Color = mActionBarDividerColor
	'Redraw
End Sub
'Height of the Dividerline of the ActionBar
Public Sub getABDividerHeight As Int 
	Return mActionBarDividerHeight
End Sub
Public Sub setABDividerHeight (ABDividerHeight As Int)
	mActionBarDividerHeight = ABDividerHeight
	pnlDivider.Height = mActionBarDividerHeight
	pnlDivider.Top = mHeight-mActionBarDividerHeight
End Sub
'Loads different drawables for the Dark-Theme
'Should be called at the very beginning as its sets back TextColor and ABBackcolor
Public Sub getDarkTheme As Boolean
	Return mDark
End Sub
Public Sub setDarkTheme (DarkTheme As Boolean)
	mDark = DarkTheme
	
	If mDark = True Then
		SetDrawable (imgArrowUp,"ahaab_back_dark")
		'imgArrowUp.Background =  LoadDrawable("ahaab_back_dark")
		Menu.DarkTheme = True
		If pnlOverflow.IsInitialized Then SetDrawable(imgOverflow,"ahaab_overflow_dark") 'imgOverflow.Background =  LoadDrawable("ahaab_overflow_dark")
		If pnlIconNavigationDrawer.IsInitialized Then SetDrawable(pnlIconNavigationDrawer,"ahaab_ic_drawer_dark") 'pnlIconNavigationDrawer.Background = LoadDrawable("ahaab_ic_drawer_dark")
		setABBackColor(Colors.Black)
		setNDTextColor(Colors.White)
		setABSubTitleTextColor(Colors.White)
		setABTitleTextColor(Colors.White)
		setNDBackColor(Colors.DarkGray)
		setABDividerColor(Colors.RGB(49,182,255))
	Else
		SetDrawable(imgArrowUp,"ahaab_back") ' LoadDrawable("ahaab_back")
		Menu.DarkTheme = False
		setABBackColor(Colors.LightGray)
		setNDTextColor(Colors.Black)
		setABSubTitleTextColor(Colors.Black)
		setABTitleTextColor(Colors.Black)
		setNDBackColor(Colors.RGB(243,243,244))
		setABDividerColor(Colors.ARGB(40 ,0,0,0))
		'SetNinePatchDrawable(pnlMenu,"ahaab_menu")
		If pnlOverflow.IsInitialized Then  SetDrawable(imgOverflow,"ahaab_overflow") 'imgOverflow.Background = LoadDrawable("ahaab_overflow")
		If pnlIconNavigationDrawer.IsInitialized Then SetDrawable(imgOverflow,"ahaab_ic_drawer") 'pnlIconNavigationDrawer.Background = LoadDrawable("ahaab_ic_drawer")
	End If

End Sub
'Use Arrow up instead of the Navigation Drawer
Public Sub setArrowUp (ArrowUp As Boolean)
	If ArrowUp = True Then
		imgArrowUp.Visible = True
		If pnlIconNavigationDrawer.IsInitialized Then
			pnlIconNavigationDrawer.Visible = False
			EnableSwipeGesture(False)
		End If
	Else
		imgArrowUp.Visible = False
		If pnlIconNavigationDrawer.IsInitialized Then
			pnlIconNavigationDrawer.Visible = True
			EnableSwipeGesture(True)
		End If
	End If
End Sub
Public Sub getArrowUp As Boolean
	Return imgArrowUp.Visible 
End Sub

'Duration of the Opening of the NavigationDrawer
Public Sub getNDOpeningDuration As Int
	Return mSideBarOpeningDuration
End Sub
Public Sub setNDOpeningDuration(NDOpeningDuration As Int)
	mSideBarOpeningDuration = NDOpeningDuration
End Sub
'Duration of the Closing of the NavigationDrawer
Public Sub getNDClosingDuration As Int
	Return mSideBarClosingDuration
End Sub
Public Sub setNDClosingDuration( NDClosingDuration As Int)
	mSideBarClosingDuration = NDClosingDuration
End Sub
'Minimumwidth of the NAvigationDrawer
Public Sub getNDWidth As Int
	Return mSideBarWidth
End Sub
Public Sub setNDWidth (NDWidth As Int)
	mSideBarWidth = NDWidth  
	pnlNavigationDrawer.Width = mSideBarWidth 
	If pnlNavigationDrawer.Left <> 0 Then pnlNavigationDrawer.Left = - mSideBarWidth
End Sub
'Background ShadowColor of the NavigationDrawer
Public Sub getNDShadowColor As Int
	Return mSideBarShadowColor
End Sub
Public Sub setNDShadowColor (NDShadowColor As Int)
	mSideBarShadowColor = NDShadowColor
	pnlShadow.Color = mSideBarShadowColor
End Sub
'Color of the NavigationDrawer Panel
Public Sub getNDBackColor As Int
	Return mSideBarBackColor
End Sub
Public Sub setNDBackColor (NDBackColor As Int)
	mSideBarBackColor = NDBackColor
	pnlNavigationDrawer.Color = mSideBarBackColor
End Sub
'Color of the Items in the NavigationDrawer
Public Sub getNDItemBackColor As Int
	Return mSideBarItemBackColor
End Sub
Public Sub setNDItemBackColor (NDItemBackColor As Int)
	mSideBarItemBackColor = NDItemBackColor
	lsvNavigationDrawer.Color = mSideBarItemBackColor
End Sub

'Returns the Panel of the Navigationdrawer so that you can add your own views etc..
Public Sub NDPanel As Panel
	Return pnlNavigationDrawer
End Sub
'Returns the Panel of the ActionBar so that you can add your own views etc..
Public Sub ABPanel As Panel
	Return pnlActionBar 
End Sub
'Returns true if the Navigation Drawer is visible
Public Sub NDisVisible As Boolean
	Return sbIsVisible
End Sub
Public Sub MenuisVisible As Boolean
	Return Menu.isVisible 
End Sub
'Sets the Scale. Use the same ratio as in your DesignerScript (AutoScaleRate)
'<B>Has to be called before Items are added</B>
'Set 0 to disable
Public Sub getAutoScaleRate As Int 
	Return mAutoScaleRate
End Sub
Public Sub setAutoScaleRate (AutoScaleRate As Int)
	mAutoScaleRate = AutoScaleRate 
	Menu.AutoScaleRate = AutoScaleRate
	
	'If mAutoScaleRate <> 1 Then
		Dim delta As Float 
		delta = ((100%x + 100%y) / (320dip + 430dip) - 1)
		mScale = 1 + mAutoScaleRate * delta
	'End If
	lsvNavigationDrawer.TwoLinesAndBitmap.Label.TextSize = mNDTextSize  * mScale
	lsvNavigationDrawer.SingleLineLayout.Label.TextSize = mNDTextSize  * mScale
End Sub
'Sets if you want to display Symbols in the Menu
'<B>Has to be set bevore Items are added </B>
Public Sub setMenuUseSymbols (MenuUseSymbols As Boolean)
	Menu.UseSymbols  =MenuUseSymbols
End Sub
Public Sub getMenuUseSymbols As Boolean 
	Return Menu.UseSymbols 
End Sub
'Sets if you want to display Symbols in the NavigationDrawer
'<B>Has to be set bevore Items are added </B>
Public Sub setNDUseSymbols (NDUseSymbols As Boolean)
	mNDUseSymbols =NDUseSymbols
End Sub
Public Sub getNDUseSymbols As Boolean 
	Return mNDUseSymbols
End Sub

Public Sub setTypeFace (NewTypeFace As Typeface)
	mTypeFace =NewTypeFace
	Menu.Typeface = mTypeFace
	lblAppSubTitle.Typeface =mTypeFace
	lblAppTitle.Typeface = mTypeFace
	setABTitle (mAppTitle)
	setABSubTitle(mAppSubTitle)
	lsvNavigationDrawer.TwoLinesAndBitmap.Label.Typeface = mTypeFace
	lsvNavigationDrawer.SingleLineLayout.Label.Typeface = mTypeFace
End Sub
Public Sub getTypeFace As Typeface
	Return mTypeFace
End Sub
#End Region 

#Region Helperfunctions
'Filters the Back & Menu Key
'Usage:
'<code>Sub Activity_KeyPress (KeyCode As Int) As Boolean
'	Return ActionBar.Keypress(KeyCode)
'End Sub</code>
Public Sub Keypress(Keycode As Int)As Boolean
	If Keycode = KeyCodes.KEYCODE_BACK OR Keycode = KeyCodes.KEYCODE_MENU Then
		If Menu.isVisible Then
			Menu.CloseMenu 
			Return True
		End If
		If NDisVisible = True Then
			CloseNavigationDrawer
			Return True
		End If
		Return False
	End If	
	Return False
End Sub
Public Sub Redraw
	If FinishedLoading = False Then Return
	
	drwButtonColor.Initialize(mButtonColor,mButtonCornerRadius)
	drwButtonPressedColor.Initialize(mButtonPressedColor,mButtonCornerRadius)

	Dim pnl As Panel
	Dim i As Int 
	
	For i = 0 To pnlActionBar.NumberOfViews - 1
		If pnlActionBar.GetView(i) Is Panel Then
			pnl = pnlActionBar.GetView(i)
			Dim sldActionButton As StateListDrawable
			sldActionButton.Initialize 
			sldActionButton.AddState(sldActionButton.State_Pressed,drwButtonPressedColor)
			sldActionButton.AddCatchAllState(drwButtonColor)
			pnl.Background  = sldActionButton
		End If
	Next
	pnlDivider.Color = mActionBarDividerColor
End Sub
Private Sub RearrangeButtons
	Dim i As Int
	Dim Left As Int  = pnlActionBar.Width 
	
	Dim v As View
	Left = Left - mHeight
	For i = 0 To lstRightButtons.Size-1
		v = lstRightButtons.get(i)
		v.Left = Left  -mHeight -1dip
		Left = v.Left 
	Next
End Sub
Private Sub CatchClick_Click
	Overflow_Click
End Sub
Private Sub SetDrawable(Control As View, Name As String)
    Try
		Dim r As Reflector
    	Dim package As String
    	Dim id As Int
		'Dim Drawable As BitmapDrawable 
    	package = r.GetStaticField("anywheresoftware.b4a.BA", "packageName")
    	id = r.GetStaticField(package & ".R$drawable", Name)
    	r.Target = r.GetContext
    	r.Target = r.RunMethod("getResources")
    	'Drawable = r.RunMethod2("getDrawable", id, "java.lang.int")
		Control.Background = r.RunMethod2("getDrawable", id, "java.lang.int")
		'Return Drawable
	Catch
		Dim bg As ColorDrawable 
		bg.Initialize(Colors.Red,0dip)
		ToastMessageShow("Drawable " & Name & " is missing." & CRLF & "Did you copy it to the Objects/res/drawable/ folder?" & CRLF & CRLF & "Don't forget to set it to read only",False)
		Control.Background = bg 
		'Return bg
	End Try
End Sub
Private Sub getParentHeight As Int
	If mActivity.Height < 0 Then
		Dim r As Reflector, RealHeight As Int
		r.Target = mActivity
		RealHeight = r.RunMethod("getHeight")
		If RealHeight = 0 Then
			DoEvents
			RealHeight = r.RunMethod("getHeight")
		End If
		Return RealHeight
	Else
		Return mActivity.Height
	End If
End Sub
Private Sub SetNinePatchDrawable(Control As View, ImageName As String)
    Try
		Dim R As Reflector
	    Dim package As String
	    Dim id As Int
	    package = R.GetStaticField("anywheresoftware.b4a.BA", "packageName")
	    id = R.GetStaticField(package & ".R$drawable", ImageName)
	    R.Target = R.GetContext
	    R.Target = R.RunMethod("getResources")
	    Control.Background = R.RunMethod2("getDrawable", id, "java.lang.int")
	Catch
		Dim bg As ColorDrawable 
		bg.Initialize(Colors.Red,0dip)
		Control.Background = bg 
		ToastMessageShow("Drawable " & ImageName & " is missing." & CRLF & "Did you copy it to the Objects/res/drawable/ folder?" & CRLF & CRLF & "Don't forget to set it to read only",False)
	End Try
End Sub
#End Region 

Private Sub SetAlpha(Control As View, Alpha As Int)
   Dim r As Reflector
   r.Target = Control.Background
   r.RunMethod2("setAlpha", Alpha, "java.lang.int")
End Sub
Private Sub GetARGB(Color As Int) As Int()
    Dim res(4) As Int
    res(0) = Bit.UnsignedShiftRight(Bit.AND(Color, 0xff000000), 24)
    res(1) = Bit.UnsignedShiftRight(Bit.AND(Color, 0xff0000), 16)
    res(2) = Bit.UnsignedShiftRight(Bit.AND(Color, 0xff00), 8)
    res(3) = Bit.AND(Color, 0xff)
    Return res
End Sub